// c1.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#import ".\gsqlparser_ao.dll"  no_namespace
#include ".\debug\gsqlparser_ao.tlh"

void pp();
void tolang();
void replacetoken();
void createparser();

/// Caller Must SysFreeString on the BSTR out parm
HRESULT StringToBSTR(char *lpzString, DWORD cbSize, BSTR &bstrString);

/// Caller must Call:
/// HeapFree(GetProcessHeap(),0,lpzString); 
/// to release allocated buffer
HRESULT BSTRToString(BSTR bstrString,char **lpzString,DWORD &buflen);

HRESULT HResultFromLastError(DWORD dwError = 0);

int main(int argc, char* argv[])
{

	if FAILED(CoInitialize(NULL))
	{
		CoUninitialize();
   	    printf("failed!\n");
		return -1;
	}
	 pp();
//	 tolang();
//	replacetoken();
	CoUninitialize();
	return 0;
}

void createparser()
{
	IGSqlParserPtr sqlparser;
	long a;
    BSTR lcbstr; 
	char  buffer[200];
	char *lpzStr = NULL;
	DWORD cbSize = 0;

   	
	for (int k = 0; k< 3000; k++){
      sqlparser.CreateInstance("gsqlparser_ao.GSqlParser");
      sqlparser->CreateInstance(DbVOracle);
	
	}
}

void pp()
{
//	using namespace gsqlparser_ao;
	IGSqlParserPtr sqlparser;
	ILzFmtOptPtr gFmtOpt;
	long a;
    BSTR lcbstr; 
	char  buffer[200];
	char *lpzStr = NULL;
	DWORD cbSize = 0;

    sqlparser.CreateInstance("gsqlparser_ao.GSqlParser");
	sqlparser->CreateInstance(DbVOracle);
   	
	for (int k = 0; k< 3; k++){
    sprintf( buffer, "%s%d", "select a,b from c where a>",k );
	sqlparser->SqlText = buffer;
	
            
	// Format Options:
    //   TCaseOption = (coUppercase,coLowercase,coInitCap,coNoChange); 
	//   TLinefeedsCommaOption = (lfAfterComma,lfBeforeComma,lfbeforeCommaWithSpace,lfNolinebreakComma);
	//   TLinefeedsAndOrOption = (lfbeforeAndOr,lfAfterAndOr,lfNolinebreak);
    //   TAssignmentOption = (aoCompact,aoFixed);
    //   TAlignOption = (aloLeft,aloRight);
    //   TAlignStyle = (asStacked,asWrapped);
    //   TAlignStyleStacked = (assCompact,assFixed);


    gFmtOpt.CreateInstance("gsqlparser_ao.LzFmtOpt");
	gFmtOpt->case_keywords = coLowercase; //coUppercase;
    gFmtOpt->Select_keywords_alignOption = aloLeft;//aloRight;
    gFmtOpt->case_keywords = coUppercase;
    gFmtOpt->case_funcname = coInitCap;
    gFmtOpt->case_identifier = coNoChange;
    gFmtOpt->LinefeedsComma_option = lfAfterComma;
    gFmtOpt->LinefeedsAndOr_option = lfbeforeAndOr;
    gFmtOpt->AndOrUnderWhere = false;
    gFmtOpt->AlignAliasInSelectList = true;
            //gFmtOpt->Select_Columnlist_Style = asStacked;
            //gFmtOpt->Insert_keywords_alignOption = aloLeft;
           // gFmtOpt->Insert_Columnlist_Style = asStacked;
           // gFmtOpt->Insert_Valuelist_Style = asStacked;
           // gFmtOpt->Select_fromclause_Style = asStacked;
           // gFmtOpt->Select_Orderby_Style = asStacked;
           // gFmtOpt->Select_Groupby_Style = asStacked;
            //gFmtOpt->Delete_keywords_alignOption = aloLeft;
            //gFmtOpt->Update_keywords_alignOption = aloLeft;
            //gFmtOpt->Update_Columnlist_Style = asStacked;
            //gFmtOpt->Expression_Align_Style = asStacked;
            //gFmtOpt->VarAlign_option = aloLeft;
            //gFmtOpt->Parameters_Style = asStacked;
            //gFmtOpt->Parameters_align_option = aloLeft;
            //gFmtOpt->Parameters_LinefeedsComma_option = lfAfterComma;
            //gFmtOpt->Createtable_Fieldlist_Style = asStacked;
            //gFmtOpt->Createtable_Fieldlist_Style_option = aloLeft;
            //gFmtOpt->Createtable_Fieldlist_Comma_option = lfAfterComma;

            //gFmtOpt.EmptyLines = eloMergeIntoOne; //eloRemove;//eloPreserve;//eloMergeIntoOne;
            // gFmtOpt->SelectItemInNewLine = false;//true;
            // gFmtOpt->FromClauseInNewLine = false;//true;
            //  gFmtOpt->CompactMode = TCompactMode.cpmugly;
            //  gFmtOpt->MaxLengthPerLine = 80;

            // use tab to ident instead of space
            // gFmtOpt->UseTab = true;
            // gFmtOpt->TabSize = 4;

            // align if,begin,else, end if keywords in a sql block
            // gFmtOpt->AlignIFStatement = true;

            // gFmtOpt->case_identifier =  TCaseOption.coInitCapEachWord;
            // dictionaryfile must be set if case_identifier is set to TCaseOption.coInitCapEachWord
            // gFmtOpt->DictionaryFile = "english.dic";

	sqlparser->PrettyPrint();
//	sqlparser->Parse(); 
//	sqlparser->GetRawSqlStatements();
    BSTRToString( (wchar_t *)sqlparser->FormattedSqlText,&lpzStr,cbSize);
 //   BSTRToString( (wchar_t *)sqlparser->VersionId,&lpzStr,cbSize);
    printf(lpzStr);
    printf("\n");
        /// Must release allocated string 
    HeapFree(GetProcessHeap(),0,lpzStr);
	}
 
}

void tolang()
{
//	using namespace gsqlparser_ao;
	IGSqlParserPtr sqlparser;
	long a;
    BSTR lcbstr; 
	char  buffer[200];
	char *lpzStr = NULL;
	DWORD cbSize = 0;

    sqlparser.CreateInstance("gsqlparser_ao.GSqlParser");
	sqlparser->CreateInstance(DbVOracle);
   	
	for (int k = 0; k< 300; k++){
    sprintf( buffer, "%s%d", "select a,b from c where a>",k );
	sqlparser->SqlText = buffer;
	
	a = sqlparser->Parse();
	if (a ==0 ){
		lcbstr = sqlparser->ToVc("var1");
        BSTRToString( lcbstr,&lpzStr,cbSize);
        printf(lpzStr);
        printf("\n");
        /// Must release allocated string 
        HeapFree(GetProcessHeap(),0,lpzStr);
	}

	}
 
}


void replacetoken()
{
//	using namespace gsqlparser_ao;
	IGSqlParserPtr sqlparser;
	ISourceTokenListPtr stl;
	ISourceTokenPtr st;

	long a;
    BSTR lcbstr; 
	char  buffer[200];
	char *lpzStr = NULL;
	DWORD cbSize = 0;
	enum ITokenStatus s;

    sqlparser.CreateInstance("gsqlparser_ao.GSqlParser");
	sqlparser->CreateInstance(DbVOracle);

	for (int k = 0; k< 1000; k++){
		sprintf( buffer, "%s%d", "select a,b from :c where a>",k );
		sqlparser->SqlText = buffer;
		a = sqlparser->Parse();
		if (a != 0 )
		{
		   BSTRToString( (wchar_t *)sqlparser->ErrorMessages,&lpzStr,cbSize);
		   printf(lpzStr);
			/// Must release allocated string 
		   HeapFree(GetProcessHeap(),0,lpzStr);
		}else{
		
			stl = sqlparser->SourceTokenList;
			for (int l = 0; l<stl->GetCount(); l++)
		   {
				st = stl->SourceTokens[l]; 
		   if (st->TokenType == ttNumber)
				{
					sprintf(buffer,"%s%d",":",k);
					st->SourceCode = buffer;
				}

		   if (st->TokenType == ttBindVar)
				{
					sprintf(buffer,"%s%d","bindvar",k);
					st->SourceCode = buffer;
				}
		   }
			BSTRToString( (wchar_t *)sqlparser->GetTextFromParseTree(),&lpzStr,cbSize);
		   printf(lpzStr);
			/// Must release allocated string 
		   HeapFree(GetProcessHeap(),0,lpzStr);
		}
	} //for 
}

/// Caller must Call:
/// HeapFree(GetProcessHeap(),0,lpzString); 
/// to release allocated buffer
HRESULT BSTRToString(BSTR bstrString,char **lpzPassedString,DWORD &buflen) {

//buflen = SysStringLen((unsigned short *)vResult.pbstrVal);

char *lpzString = NULL;

__try {
	buflen = SysStringLen(bstrString);
	if (buflen == 0)  {
	   *lpzPassedString = NULL;
	   return 0;
	}

	lpzString = (char *) HeapAlloc (GetProcessHeap (), 0, buflen + 1); 
	if (!lpzString) 
	   return HResultFromLastError();


	/// ***  4th parm (Buflen) parameter must not be the default (-1) or NULLs will terminate the string
	if (0 == WideCharToMultiByte(CP_ACP, 0, bstrString, buflen, 
								 lpzString, buflen + 1, NULL, NULL)) {
	   buflen = 0;
	   *lpzPassedString = NULL;
	   return HResultFromLastError();
	}

	// null terminate string
	*(lpzString + buflen) = 0;  // This is not really necessary but

	*lpzPassedString = lpzString;
}
__except(EXCEPTION_EXECUTE_HANDLER) {
    __try { 
		if (lpzString)
			 HeapFree(GetProcessHeap(),0,lpzString);
	}
     __except(EXCEPTION_EXECUTE_HANDLER) {;}

	 *lpzPassedString = NULL;
	 buflen = 0;
     return -1;
}

return 0;
}

/// Caller must call SysFreeString() on bstr
HRESULT StringToBSTR(char *lpzString, DWORD cbSize, BSTR &bstrString) {

    OLECHAR *wzString = NULL;

__try {
    bstrString = NULL;

    if (cbSize == 0)  {
		if (!lpzString) {
			bstrString = NULL;
			return 0;
		}
		cbSize = strlen(lpzString);
	}

	wzString = (OLECHAR *) HeapAlloc (GetProcessHeap (), 0, cbSize * 2 + 2  );
	if (wzString == NULL) 
		return HResultFromLastError();

	if (0 == MultiByteToWideChar(CP_ACP, 0, (const char*)lpzString, cbSize, wzString, cbSize ) ) 
		return HResultFromLastError();

	bstrString = SysAllocStringLen(wzString,cbSize);
	if (NULL == bstrString) 
		return HResultFromLastError();

    /// Release the Wide character string
	__try {
		HeapFree(GetProcessHeap(),0,wzString);
	}
    __except(EXCEPTION_EXECUTE_HANDLER) {
        return -1;
	}
}
__except(EXCEPTION_EXECUTE_HANDLER) {
	__try {
		if (wzString)
			HeapFree(GetProcessHeap(),0,wzString);
		if (bstrString)
			SysFreeString(bstrString);
	}
    __except(EXCEPTION_EXECUTE_HANDLER) {;}

	bstrString = NULL;    
	return -1;
}

	return 0;
}


HRESULT HResultFromLastError(DWORD dwError)
{
    if (dwError == 0) 
	   dwError = GetLastError();

	return HRESULT_FROM_WIN32(dwError);
}

